namespace CSLint
{
    using System;
	
	
    public class CallContext
    {
        internal CallContext    next;
        internal CallContext    breadthFirst;
        internal CallContext    up;
        internal InvocationDesc inv;
        internal GraphVertex[]  monitors;
		
        internal static CallContext entryPoint = new CallContext();
        internal static CallContext monitorEnter = new CallContext();
		
        internal bool equalState(CallContext cc)
        {
            if ((CSLint.instance.reportAllLoops && inv != cc.inv) 
                || monitors.Length != cc.monitors.Length)
            {
                return false;
            }
            for (int i = monitors.Length; --i >= 0; )
            {
                if (monitors[i] != cc.monitors[i])
                {
                    return false;
                }
            }
            return true;
        }
		
        internal CallContext()
        {
            monitors = new GraphVertex[0];
        }
		
        internal CallContext(CallContext parent, CallContext sibling, InvocationDesc invocation)
        {
            int i, j;
            int nMonitors = parent.monitors.Length;
            for (i = invocation.monitors.Length; --i >= 0; )
            {
                for (j = parent.monitors.Length; --j >= 0; )
                {
                    if (invocation.monitors[i] == parent.monitors[j])
                    {
                        break;
                    }
                }
                if (j < 0)
                {
                    nMonitors += 1;
                }
            }
            if (nMonitors == parent.monitors.Length)
            {
                monitors = parent.monitors;
            }
            else if (parent.monitors.Length == 0)
            {
                monitors = invocation.monitors;
            }
            else
            {
                monitors = new GraphVertex[nMonitors];
                for (j = nMonitors = parent.monitors.Length; --j >= 0; monitors[j] = parent.monitors[j]);
                for (i = 0; i < invocation.monitors.Length; i++)
                {
                    for (j = parent.monitors.Length; --j >= 0; )
                    {
                        if (invocation.monitors[i] == parent.monitors[j])
                        {
                            break;
                        }
                    }
                    if (j < 0)
                    {
                        monitors[nMonitors++] = invocation.monitors[i];
                    }
                }
            }
            up = parent;
            breadthFirst = sibling;
            inv = invocation;
        }
    }
}