namespace CSLint
{
    using System;
    using System.Reflection;
	
    public class ClassDesc
    {
        internal MethodDesc  methods;
        internal FieldDesc   fields;
		
        internal Type        cls;
        internal GraphVertex classMonitor;
        internal GraphVertex metaclassMonitor;
		
        internal ClassDesc(Type type)
        {
            cls = type;
            classMonitor = new GraphVertex();
            classMonitor.syncClass = this;
            metaclassMonitor = new GraphVertex();
            metaclassMonitor.syncMetaclass = this;
        }
		
        internal MethodDesc addMethod(MethodBase mth)
        {
            return methods = new MethodDesc(methods, this, mth);
        }		

        internal MethodDesc getMethod(MethodBase mth)
        {
            for (MethodDesc md = methods; md != null; md = md.next)
            {
                if (md.method == mth)
                {
                    return md;
                }
            }
            return addMethod(mth);
        }
		
        internal FieldDesc getField(FieldInfo fi)
        {
            for (FieldDesc fd = fields; fd != null; fd = fd.next)
            {
                if (fd.field == fi)
                {
                    return fd;
                }
            }
            return addField(fi);
        }
		
        internal FieldDesc addField(FieldInfo fi)
        {
            return fields = new FieldDesc(fields, fi);
        }
		
        internal void addOverriddenMethodInvocations()
        {
            if (cls != typeof(Object)) 
            {
                for (MethodDesc mth = methods; mth != null; mth = mth.next)
                {
                    mth.addOverriddenMethodInvocations();
                }
            }
        }		

        internal String getSourceFilePath() 
        {
            // TODO: I don't know how extract symbolic infromation from CLI
            return null;
        }
    }
}